"use strict";

exports.__esModule = true;
exports.css = exports.styled = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireDefault(require("react"));

var _props2 = _interopRequireDefault(require("./props"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function omitNonHostProps(props) {
  var result = {};
  Object.keys(props).forEach(function (key) {
    if (_props2.default.test(key)) result[key] = props[key];
  });
  return result;
}

var styled = function styled(type, displayName, styles, getStyles) {
  var styleMap = getStyles(styles);
  var omit = typeof type === 'string' ? omitNonHostProps : null;

  function Styled(_props) {
    var props = omit ? omit(_props) : _extends({}, _props);
    delete props.innerRef;
    props.ref = _props.innerRef;
    props.className = (0, _classnames.default)(props.className, styleMap.map(function (s) {
      return typeof s === 'string' ? s : s(_props);
    }));
    return _react.default.createElement(type, props);
  }

  Styled.displayName = displayName;

  Styled.withComponent = function (nextType) {
    return styled(nextType, displayName, styles, getStyles);
  };

  return _react.default.forwardRef ? _react.default.forwardRef(function (props, ref) {
    return _react.default.createElement(Styled, _extends({
      innerRef: ref
    }, props));
  }) : Styled;
};

exports.styled = styled;

var css = function css() {
  throw new Error('`css` template literal evaluated at runtime!');
};

exports.css = css;